#
# Copyright (c) 2004, 2005 Ralf Corsepius, Ulm, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#

Name:           Inventor
Version:        2.1.5
Release:        12%{?dist}

Summary:        SGI Open Inventor (TM)

Group:          System Environment/Libraries
License:        LGPL
URL:            http://oss.sgi.com/projects/inventor/
Source0:        ftp://oss.sgi.com/projects/inventor/download/inventor-2.1.5-10.src.tar.gz
# Debian patch
Patch0:         inventor_2.1.5-10-2.diff
# fix broken GNUmakefiles
Patch1:		Inventor-apps.diff
# fixes one of the GNUmakefile bugs (currently unused)
Patch2:		Inventor-libSoXt.diff
# use bison
Patch3:		Inventor-yacc.diff
# use /bin/csh (Revert debian patch)
Patch4:		Inventor-makeManDirs.diff
# Add libdl to libInventor
Patch5:		Inventor-libInventor.diff
# Add libgl to Decal.so
Patch6:		Inventor-decal.diff
# Add pkgconfig support
Patch7:		Inventor-pkgconfig.diff
# Declare SoTempPath forward
Patch8:		Inventor-SoPath.diff

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  xorg-x11-Mesa-libGLU
BuildRequires:  xorg-x11-Mesa-libGL
BuildRequires:	xorg-x11-devel
BuildRequires:	openmotif-devel freetype-devel libjpeg-devel
BuildRequires:	bison
# Workaround to RH shipping bison with broken package dependencies
BuildRequires:	m4
BuildRequires:	/bin/csh

%description
SGI Open Inventor(TM) is an object-oriented 3D toolkit offering a
comprehensive solution to interactive graphics programming
problems. It presents a programming model based on a 3D scene database
that dramatically simplifies graphics programming. It includes a rich
set of objects such as cubes, polygons, text, materials, cameras,
lights, trackballs, handle boxes, 3D viewers, and editors that speed
up your programming time and extend your 3D programming capabilities.


%package        devel
Summary:        SGI Open Inventor (TM) development files
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:	pkgconfig
Requires:	xorg-x11-devel
Requires:	freetype-devel libjpeg-devel

%description    devel
SGI Open Inventor (TM) development files.

%package        -n InventorXt
Summary:        SGI Open Inventor (TM) Motif bindings.
Group:          System Environment/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:	pkgconfig

%description    -n InventorXt
SGI Open Inventor (TM) development files.

%package        -n InventorXt-devel
Summary:        SGI Open Inventor (TM) Motif bindings.
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:	InventorXt = %{version}-%{release}
Requires:	Inventor-devel = %{version}-%{release}
Requires:	pkgconfig
Requires:	openmotif-devel

%description    -n InventorXt-devel
SGI Open Inventor (TM) development files.

%package	demos
Summary:	SGI Open Inventor (TM) Demos
Group:		Development/Demos
Requires:	%{name}-data

%description	demos
SGI Open Inventor (TM) demos.

%package	data
Summary:	SGI Open Inventor (TM) data
Group:		Development/Data

%description	data
SGI Open Inventor data files.

%package	examples
Summary:	SGI Open Inventor (TM) source code examples
Group:		Development/Demos
# Should we once ship binary examples, this requirement can be dropped
Requires:	InventorXt-devel

%description	examples
SGI Open Inventor (TM) Source Examples from the Inventor books
"The Inventor Mentor" and "The Inventor Toolmaker".

%prep
%setup -q -n inventor
%patch0 -p1 -b .debian
%patch1 -p0
# %patch2 -p0 -b .orig
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p1

grep -Rl __ia64 lib* | while read a; do \
  sed -i -e 's,__ia64,__ia64__,g' \
  -e 's,__ia64____,__ia64__,g' \
  -e 's,__ia64__,__ia64__ || __x86_64__,g' \
  $a; 
done

sed -i \
-e 's,^IVPREFIX =.*$,IVPREFIX = %{_prefix},' \
-e 's,^_BINDIR =.*$,_BINDIR = %{_bindir},' \
-e 's,^_LIBDIR =.*$,_LIBDIR = %{_libdir},' \
-e 's,^_HDRTOP =.*$,_HDRTOP = %{_includedir}/Inventor,' \
-e 's,^_MAN1DIR =.*$,_MAN1DIR = %{_mandir}/man1,' \
-e 's,^_MAN3DIR =.*$,_MAN3DIR = %{_mandir}/man3,' \
-e 's,^_FONTPATH =.*$,_FONTPATH = %{_datadir}/%{name}/fonts,' \
-e 's,^_HELPDIR =.*$,_HELPDIR = %{_datadir}/%{name}/help,' \
-e 's,^_DATADIR =.*$,_DATADIR = %{_datadir}/%{name}/data/models,' \
-e 's,^_MATERIALSDIR =.*$,_MATERIALSDIR = %{_datadir}/%{name}/data/materials,' \
-e 's,^_TEXTURESDIR =.*$,_TEXTURESDIR = %{_datadir}/%{name}/data/textures,' \
-e 's,^_DEMOBINDIR =.*$,_DEMOBINDIR = %{_libdir}/Inventor,' \
-e 's,^_DEMODATADIR =.*$,_DEMODATADIR = %{_datadir}/%{name}/data/demos,' \
-e 's,^OPTIMIZER = -O -DNDEBUG,OPTIMIZER = -DNDEBUG,' \
-e 's,(X11DIR)/lib,(X11DIR)/%_lib,g' \
make/ivcommondefs

for i in apps/demos/*/*.RUNME; do \
  sed -i \
    -e 's,/usr/share/inventor/,%{_datadir}/%{name}/,g' \
    -e 's,/usr/lib/inventor/,%{_libdir}/Inventor/,g' \
    $i
done

for i in *.pc.in; do
  sed \
    -e 's,@prefix@,%_prefix,g' \
    -e 's,@exec_prefix@,%_exec_prefix,g' \
    -e 's,@includedir@,%_includedir,g' \
    -e 's,@libdir@,%_libdir,g' \
    -e 's,X11R6/lib,X11R6/%_lib,g' \
    < $i > $(basename $i .in)
done

%build
# Inventor's build system wants us to install and build everything at once.
rm -rf $RPM_BUILD_ROOT
export LD_LIBRARY_PATH=${RPM_BUILD_ROOT}%{_libdir}
%ifarch ppc
# Work around g++ ICE bug (RH bugzilla #146988)
export RPM_OPT_FLAGS="${RPM_OPT_FLAGS} -O1"
%endif
export VCOPTS="${RPM_OPT_FLAGS} -D_REENTRANT"
export VCXXOPTS="${RPM_OPT_FLAGS} -D_REENTRANT"
make all \
  FREETYPE=1 IVROOT=${RPM_BUILD_ROOT} \
  LSUBDIRS="libimage tools libFL"
make install \
  FREETYPE=1 IVROOT=${RPM_BUILD_ROOT}
  LSUBDIRS="lib libSoXt"
make all \
  FREETYPE=1 IVROOT=${RPM_BUILD_ROOT} BUILDMAN=1 \
  LSUBDIRS="doc data apps"

# convert Mentor and Toolmaker examples into a standalone package
rm -rf devel-docs
cp -a apps/examples devel-docs
cp -a make devel-docs
pushd devel-docs > /dev/null
find -name CVS | xargs rm -rf
find \( -name '*~' -o -name '*.debian' \) -exec rm -f {} \;
find -name 'GNUmakefile*' | while read a; do \
  b=`echo $a | sed 's,GNUmakefile.*$,,;s,^\./,,;s,[^/]*/,../,g;s,\/$,,;s,^$,.,'`
  sed -i -e "s,^IVDEPTH = .*$,IVDEPTH = $b," $a
done
find -name '*.c++' | while read a; do \
  sed -i -e "s,/usr/share/src/Inventor/examples/data,%{_libdir}/Inventor/examples/data,g" $a
done
sed -i -e '/^IVLIBHDRDIRS.*/,/libSoXt\/include/c\
IVLIBHDRS = `pkg-config --cflags libInventorXt`' \
make/ivcommondefs
make clean
popd > /dev/null

%install
rm -rf $RPM_BUILD_ROOT
export LD_LIBRARY_PATH=${RPM_BUILD_ROOT}%{_libdir}
export VCOPTS="${RPM_OPT_FLAGS} -D_REENTRANT"
export VCXXOPTS="${RPM_OPT_FLAGS} -D_REENTRANT"
make install \
  FREETYPE=1 IVROOT=${RPM_BUILD_ROOT} BUILDMAN=1

install -d -m755 ${RPM_BUILD_ROOT}%{_libdir}/pkgconfig
install -m644 libInventor.pc ${RPM_BUILD_ROOT}%{_libdir}/pkgconfig
install -m644 libInventorXt.pc ${RPM_BUILD_ROOT}%{_libdir}/pkgconfig

install -d m755 ${RPM_BUILD_ROOT}%{_libdir}/Inventor
mv devel-docs ${RPM_BUILD_ROOT}%{_libdir}/Inventor/examples

%clean
rm -rf $RPM_BUILD_ROOT


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc COPYING README.FIRST KNOWN.BUGS FAQ.misc
%{_bindir}/iv2toiv1
%{_bindir}/ivcat
%{_bindir}/ivdowngrade
%{_bindir}/ivfix
%{_bindir}/ivinfo
%{_bindir}/ivnorm
%{_bindir}/ivAddVP
%{_libdir}/libInventor.so.*
%{_mandir}/man1/inventor.*
%{_mandir}/man1/iv2toiv1.*
%{_mandir}/man1/ivcat.*
%{_mandir}/man1/ivdowngrade.*
%{_mandir}/man1/ivfix.*
%{_mandir}/man1/ivinfo.*

%files devel
%defattr(-,root,root,-)
%dir %{_includedir}/Inventor
%{_includedir}/Inventor/[^X]*
%{_libdir}/libInventor.so
%{_libdir}/pkgconfig/libInventor.pc
%{_mandir}/man3/Sb*
%{_mandir}/man3/So[^X]*


%post -n InventorXt -p /sbin/ldconfig

%postun -n InventorXt -p /sbin/ldconfig

%files -n InventorXt
%defattr(-,root,root,-)
%{_bindir}/SceneViewer
%{_bindir}/ivview
%{_bindir}/ivperf
%{_mandir}/man1/SceneViewer.*
%{_mandir}/man1/ivview.*
%{_libdir}/libInventorXt.so.*
%{_datadir}/%{name}

%files -n InventorXt-devel
%defattr(-,root,root,-)
%dir %{_includedir}/Inventor
%{_includedir}/Inventor/Xt
%{_libdir}/libInventorXt.so
%{_libdir}/pkgconfig/libInventorXt*.pc
%{_mandir}/man3/SoXt*

%files data
%defattr(-,root,root,-)
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/data
%{_datadir}/%{name}/data/models

%files demos
%defattr(-,root,root,-)
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/data
%{_datadir}/%{name}/data/demos
%dir %{_libdir}/Inventor
%{_libdir}/Inventor/[^e]*

%files examples
%defattr(-,root,root,-)
%dir %{_libdir}/Inventor
%{_libdir}/Inventor/examples

%changelog
* Tue Jul 02 2005 Ralf Corsepius <ralf[AT]links2linux.de> - 2.1.5-12
- Add SoTempPath fix.

* Sun May 22 2005 Ralf Corsepius <ralf[AT]links2linux.de> - 2.1.5-9
- Increment release in an attempt to please build system.

* Sun May 22 2005 Ralf Corsepius <ralf[AT]links2linux.de> - 2.1.5-8
- Use BR: xorg-x11-* instead of *.so.1 to work around rpm's brain-dead
  SONAME handling.
- Add %%dist.
- Use sed -i to avoid temporary files.

* Fri Apr  7 2005 Michael Schwendt <mschwendt[AT]users.sf.net>
- rebuilt

* Wed Feb 16 2005 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 2.1.5-7
- Add specfile-patch from Andy Loening to fix build on x86_64 (rhb#147267)

* Mon Feb 14 2005 David Woodhouse <dwmw2 infradead org> - 2.1.5-6
- Work around gcc bug by backing down to -O1 on ppc

* Mon Sep 6 2004 Ralf Corsepius <ralf[AT]links2linux.de> - 2.1.5-0.fdr.5
- Add ivAddVP ivnorm ivperf to Inventor rsp. InventorXt.
- Remove BuildRequires: tcsh.

* Wed Aug 8 2004 Ralf Corsepius <ralf[AT]links2linux.de> - 2.1.5-0.fdr.4
- Split out InventorXt, InventorXt-devel, Inventor-examples
- make/ivcommondefs: Remove -O from $OPTIMIZER.
- Various changes to libInventor.pc and libInventorXt.pc.

* Wed Jul 7 2004 Ralf Corsepius <ralf[AT]links2linux.de> - 2.1.5-0.fdr.3
- Remove Mesa-Requires.
- Add pkgconfig support.
- Add various Requires: to *devel.
- Add Provides: InventorXt and InventorXt-devel.

* Thu Jul 1 2004 Ralf Corsepius <ralf[AT]links2linux.de> - 2.1.5-0.fdr.2
- Adopt portions of Michael Schwendt's patch.
- Fix hard-coded paths in apps/demos/*.RUNMEs.
- Use %{_prefix}/lib instead of %{_libdir} to install the demos into.
- Add make/ to devel docs.
- Hack devel docs to be buildable.

* Wed Jun 30 2004 Ralf Corsepius <ralf[AT]links2linux.de> - 2.1.5-0.fdr.1
- Initial Fedora Extras RPM.
- Adopt Debian/Testing patches (Thanks to Steve M. Robbins for keeping
  Inventor alive).
